# What is Archipel ?

Archipel is an Open Source project that aims to bring push notifications to 
virtualization orchestration using XMPP.

Archipel relies on open source technologies like python, ejabberd, cappuccino, 
strophe, nginx, libvirt, KVM and even more. All of these  technologies are mixed 
together to create a real time orchestration solution for virtualization.

Thanks to Archipel you are be able to :

* Visualize in real time the states of virtual machines and hypervisors ;
* Send real time commands to them ;
* Communicate inside the orchestrator with other human users ;
* Organize virtual machines and hypervisors into groups and send commands to them ;
* Connect distant datacenters in a secure way using XMPP S2S communication ;
* Even use Archipel with XMPP client like GMail in order to receive your VMs notifications ;
* Avoid the presence of SPOF. If a something fails, everything else still works ;
* Use it with KVM, Xen, OpenVZ, VirtualBox, and mix them all if you want to ;
* Have a great real time interface.
* And so much more to come!


# Get help

* Website : <http://archipelproject.org>
* Nighty Builds : <http://nightlies.archipelproject.org>
* Test application : <http://app.archipelproject.org>
* Mailing list : <http://groups.google.com/group/archipelproject>
* IRC : <irc://irc.freenode.net/#archipel>
* Sources : <https://github.com/primalmotion/archipel>
* Wiki : <https://github.com/primalmotion/archipel/wiki>
* Bugtracker : <https://github.com/primalmotion/archipel/issues>
* FAQ : <https://github.com/primalmotion/Archipel/wiki/Faq>


# Installation

The complete installation procedure can be found at <https://github.com/primalmotion/archipel/wiki>.
If you find some errors, please feel free to correct them.


# Team

* Antoine Mercadal (primalmotion)   : Lead developer

* Franck Villaume (nerville)        : contributor
* Alexandre Fernandez (crashtest)   : contributor
* Ben Langfeld (benlangfedl)        : StropheCappuccino contributor
* David Weber  (david-weber)        : contributor
* Anonymous (npmap)                 : contributor


# Thanks

* Alexandre Fernadez (crashtext)    : main website hosting
* 


# License

Archipel is distributed under AGPL v3. See the LICENSE file